/**
  ******************************************************************************
  * @file    BSP/Inc/tft_v2.h
  * @author
  * @brief   Header for tft_v2.c module
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 UTIA AV CR, v.v.i.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __TFT_V2_H
#define __TFT_V2_H

#ifdef __cplusplus
 extern "C" {
#endif


/* Includes ------------------------------------------------------------------*/
// #include <stdio.h>
// #include <stdlib.h>
// #include "stm32h7xx_nucleo_144.h"
// #include "stm32_adafruit_sd.h"
// #include "stm32_adafruit_lcd.h"
// #include "stm32h743xx.h"
#include "stm32h7xx_hal_i2c.h"

/* Exported typedef -----------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/

#define TFTSHIELD_V2_I2C_ADDR (0x2E << 1)

#define TFTSHIELD_V2_RESET_PIN (1ul << 3)


#define TFTSHIELD_V2_BUTTON_UP_PIN 6
#define TFTSHIELD_V2_BUTTON_UP (1UL << TFTSHIELD_V2_BUTTON_UP_PIN)

#define TFTSHIELD_V2_BUTTON_DOWN_PIN 9
#define TFTSHIELD_V2_BUTTON_DOWN (1UL << TFTSHIELD_V2_BUTTON_DOWN_PIN)

#define TFTSHIELD_V2_BUTTON_LEFT_PIN 8
#define TFTSHIELD_V2_BUTTON_LEFT (1UL << TFTSHIELD_V2_BUTTON_LEFT_PIN)

#define TFTSHIELD_V2_BUTTON_RIGHT_PIN 5
#define TFTSHIELD_V2_BUTTON_RIGHT (1UL << TFTSHIELD_V2_BUTTON_RIGHT_PIN)

#define TFTSHIELD_V2_BUTTON_IN_PIN 7
#define TFTSHIELD_V2_BUTTON_IN (1UL << TFTSHIELD_V2_BUTTON_IN_PIN)

#define TFTSHIELD_V2_BUTTON_1_PIN 10
#define TFTSHIELD_V2_BUTTON_1 (1UL << TFTSHIELD_V2_BUTTON_1_PIN)

#define TFTSHIELD_V2_BUTTON_2_PIN 11
#define TFTSHIELD_V2_BUTTON_2 (1UL << TFTSHIELD_V2_BUTTON_2_PIN)

#define TFTSHIELD_V2_BUTTON_3_PIN 14
#define TFTSHIELD_V2_BUTTON_3 (1UL << TFTSHIELD_V2_BUTTON_3_PIN)

#define TFTSHIELD_V2_BUTTON_ALL (TFTSHIELD_V2_BUTTON_UP | TFTSHIELD_V2_BUTTON_DOWN | TFTSHIELD_V2_BUTTON_LEFT \
                               | TFTSHIELD_V2_BUTTON_RIGHT | TFTSHIELD_V2_BUTTON_IN | TFTSHIELD_V2_BUTTON_1 \
                               | TFTSHIELD_V2_BUTTON_2 | TFTSHIELD_V2_BUTTON_3)

#define SHIELD_V2_NOT_DETECTED 	0
#define SHIELD_V2_DETECTED		1


/* Exported functions ------------------------------------------------------- */
void TFT_V2_ShieldInit(I2C_HandleTypeDef *I2cHandle);
uint8_t TFT_V2_ShieldDetect(I2C_HandleTypeDef *I2cHandle);
JOYState_TypeDef TFT_V2_Shield_JOY_GetState(I2C_HandleTypeDef *I2cHandle);


#endif /* __MAIN_H */

/************************ (C) COPYRIGHT UTIA AV CR, v.v.i *****END OF FILE****/

